<template>
    <section class="ftco-section contact-section ftco-no-pb js-fullheight" id="contact-section">
        <div class="container">

            <div class="row justify-content-center mb-1">
                <div class="col-md-7 heading-section text-center ftco-animate">
                    <h1 class="big big-2">Contact</h1>
                    <h2 class="mb-4">Contact Me</h2>
                    <div class="alert alert-success" v-if="post_contact_form_status">
                        {{ post_contact_form_message }}
                    </div>
                    <div class="alert alert-danger" v-if="post_contact_form_errors.length > 0">
                        <p v-for="errors in post_contact_form_errors">{{ errors }}</p>
                    </div>
                </div>
            </div>


            <div class="row no-gutters block-9 mb-1">
                <div class="col-12 order-md-last d-flex bg-light">
                    <form id="contactForm" @submit="postContactForm" class="p-4 p-md-5 contact-form">
                        <input type="hidden" name="_token" :value="tokens.csrf_token">
                        <div class="form-group">
                            <div class="row">

                                <div class="col-12 col-md-6">
                                    <input type="text" class="form-control" placeholder="Your Name" name="name"
                                           v-model="cf_name">
                                    <span class="text-danger"></span>
                                </div>
                            </div>
                        </div>
                        <div class="form-group">
                            <div class="row">
                                <div class="col-12 col-md-6">

                                    <input type="text" class="form-control" placeholder="Your Email" name="email"
                                           v-model="cf_email">
                                    <span class="text-danger"></span>
                                </div>
                            </div>
                        </div>
                        <div class="form-group">
                            <div class="row">
                                <div class="col-12">
                                    <input type="text" class="form-control" placeholder="Subject" name="subject"
                                           v-model="cf_subject">
                                    <span class="text-danger"></span>
                                </div>
                            </div>
                        </div>
                        <div class="form-group">
                            <div class="row">
                                <div class="col-12">
                                    <textarea name="message" cols="30" rows="7" class="form-control"
                                              placeholder="Message"
                                              v-model="cf_message"></textarea>
                                    <span class="text-danger"></span>
                                </div>
                            </div>
                        </div>

                        <vue-recaptcha
                            ref="recaptcha"
                            v-bind:sitekey="tokens.g_racaptcha_token"
                            @verify="onVerified"
                            @expired="recaptchaExpired"
                        ></vue-recaptcha>

                        <div class="form-group mt-2">
                            <div class="row">
                                <div class="col-12">

                                    <button
                                        type="submit" id="button_send_message"
                                        class="btn btn-primary py-3 px-5"
                                        v-bind:disabled="!isHuman"
                                    >Send Message
                                    </button>
                                </div>
                            </div>
                        </div>
                    </form>

                </div>
            </div>
        </div>
    </section>
</template>

<script>

    import VueRecaptcha from 'vue-recaptcha';

    export default {
        name: 'Contact',
        components: {
            VueRecaptcha,
        },
        data() {
            return {
                isHuman: false,
                post_contact_form_status: null,
                post_contact_form_message: "",
                post_contact_form_errors: [],
                cf_name: '',
                cf_email: '',
                cf_subject: '',
                cf_message: '',
                tokens: {
                    csrf_token: document.getElementById("meta-csrf-token").getAttribute("content"),
                    g_racaptcha_token: document.getElementById("meta-g-recaptcha").getAttribute("content"),
                },
            }
        },
        props: {
            cms: Object,
            fullHeight: Function,
            loader: Function,
            contentWayPoint: Function,
        },
        mounted() {
            // console.log("tokens: " + this.tokens.csrf_token + " ::: " + this.tokens.g_racaptcha_token);
            this.fullHeight();
            this.loader();
            this.contentWayPoint();
        },
        methods: {

            onVerified(response) {
                console.log('Verify: ' + response);
                this.isHuman = true;
            },
            recaptchaExpired() {
                console.log('Expired');
            },
            buttonLoader(btn) {
                btn.setAttribute("disabled", "disabled");
                btn.innerHTML = '<span class="spinner-border spinner-border-sm" role="status" aria-hidden="true"></span>  Please wait...';
            },
            buttonLoaderReset(btn, label) {
                btn.removeAttribute("disabled");
                btn.innerHTML = label;
            },
            postContactForm(e) {
                e.preventDefault();
                let currentObject = this;
                let submitButton = document.getElementById('button_send_message');
                this.buttonLoader(submitButton);

                this.post_contact_form_errors = [];

                if (this.cf_name === '') {
                    this.post_contact_form_errors.push('Name is required');
                    this.buttonLoaderReset(submitButton, 'Send Message');
                    return;
                }
                if (this.cf_email === '') {
                    this.post_contact_form_errors.push('Email is required');
                    this.buttonLoaderReset(submitButton, 'Send Message');
                    return;
                }
                if (this.cf_subject === '') {
                    this.post_contact_form_errors.push('Subject is required');
                    this.buttonLoaderReset(submitButton, 'Send Message');
                    return;
                }
                if (this.cf_message === '') {
                    this.post_contact_form_errors.push('Message is required');
                    this.buttonLoaderReset(submitButton, 'Send Message');
                    return;
                }

                let url = document.querySelector('meta[name=base-url]').getAttribute("content") + '/api/contactForm/';

                const formData = new FormData(document.getElementById("contactForm"));

                this.axios.post(url, formData)
                    .then(function (response) {

                        //console.log(response);

                        if (response.data.status === "success") {

                            currentObject.post_contact_form_status = true;
                            currentObject.post_contact_form_message = response.data.message;
                            currentObject.cf_name = '';
                            currentObject.cf_email = '';
                            currentObject.cf_subject = '';
                            currentObject.cf_message = '';
                        } else {
                            currentObject.post_contact_form_status = false;
                            currentObject.post_contact_form_errors.push(response.data.message);
                        }
                        currentObject.buttonLoaderReset(submitButton, 'Send Message');
                    })
                    .catch(function (error) {
                        currentObject.post_contact_form_errors.push(error);
                        currentObject.buttonLoaderReset(submitButton, 'Send Message');
                    });
            },
        },
    }
</script>
<style scoped>
    .form-group {
        margin-bottom: 0 !important;
    }
</style>
